"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// dist/deltachat.js
var deltachat_exports = {};
__export(deltachat_exports, {
  BaseDeltaChat: () => BaseDeltaChat,
  C: () => C,
  DEFAULT_OPTS: () => DEFAULT_OPTS,
  DeltaChat: () => DeltaChat,
  RPC: () => jsonrpc_exports,
  RawClient: () => RawClient,
  StdioDeltaChat: () => StdioDeltaChat,
  StdioTransport: () => StdioTransport,
  T: () => types_exports,
  yerpc: () => yerpc
});
module.exports = __toCommonJS(deltachat_exports);

// dist/generated/jsonrpc.js
var jsonrpc_exports = {};

// dist/generated/types.js
var types_exports = {};

// dist/generated/client.js
var RawClient = class {
  constructor(_transport) {
    this._transport = _transport;
  }
  /**
   * Test function.
   */
  sleep(delay) {
    return this._transport.request("sleep", [delay]);
  }
  /**
   * Checks if an email address is valid.
   */
  checkEmailValidity(email) {
    return this._transport.request("check_email_validity", [email]);
  }
  /**
   * Returns general system info.
   */
  getSystemInfo() {
    return this._transport.request("get_system_info", []);
  }
  /**
   * Get the next event.
   */
  getNextEvent() {
    return this._transport.request("get_next_event", []);
  }
  addAccount() {
    return this._transport.request("add_account", []);
  }
  removeAccount(accountId) {
    return this._transport.request("remove_account", [accountId]);
  }
  getAllAccountIds() {
    return this._transport.request("get_all_account_ids", []);
  }
  /**
   * Select account id for internally selected state.
   * TODO: Likely this is deprecated as all methods take an account id now.
   */
  selectAccount(id) {
    return this._transport.request("select_account", [id]);
  }
  /**
   * Get the selected account id of the internal state..
   * TODO: Likely this is deprecated as all methods take an account id now.
   */
  getSelectedAccountId() {
    return this._transport.request("get_selected_account_id", []);
  }
  /**
   * Get a list of all configured accounts.
   */
  getAllAccounts() {
    return this._transport.request("get_all_accounts", []);
  }
  /**
   * Starts background tasks for all accounts.
   */
  startIoForAllAccounts() {
    return this._transport.request("start_io_for_all_accounts", []);
  }
  /**
   * Stops background tasks for all accounts.
   */
  stopIoForAllAccounts() {
    return this._transport.request("stop_io_for_all_accounts", []);
  }
  /**
   * Starts background tasks for a single account.
   */
  startIo(accountId) {
    return this._transport.request("start_io", [accountId]);
  }
  /**
   * Stops background tasks for a single account.
   */
  stopIo(accountId) {
    return this._transport.request("stop_io", [accountId]);
  }
  /**
   * Get top-level info for an account.
   */
  getAccountInfo(accountId) {
    return this._transport.request("get_account_info", [accountId]);
  }
  /**
   * Get the combined filesize of an account in bytes
   */
  getAccountFileSize(accountId) {
    return this._transport.request("get_account_file_size", [accountId]);
  }
  /**
   * Returns provider for the given domain.
   *
   * This function looks up domain in offline database.
   *
   * For compatibility, email address can be passed to this function
   * instead of the domain.
   */
  getProviderInfo(accountId, email) {
    return this._transport.request("get_provider_info", [accountId, email]);
  }
  /**
   * Checks if the context is already configured.
   */
  isConfigured(accountId) {
    return this._transport.request("is_configured", [accountId]);
  }
  /**
   * Get system info for an account.
   */
  getInfo(accountId) {
    return this._transport.request("get_info", [accountId]);
  }
  /**
   * Sets the given configuration key.
   */
  setConfig(accountId, key, value) {
    return this._transport.request("set_config", [accountId, key, value]);
  }
  /**
   * Updates a batch of configuration values.
   */
  batchSetConfig(accountId, config) {
    return this._transport.request("batch_set_config", [accountId, config]);
  }
  /**
   * Set configuration values from a QR code. (technically from the URI that is stored in the qrcode)
   * Before this function is called, `checkQr()` should confirm the type of the
   * QR code is `account` or `webrtcInstance`.
   *
   * Internally, the function will call dc_set_config() with the appropriate keys,
   */
  setConfigFromQr(accountId, qrContent) {
    return this._transport.request("set_config_from_qr", [accountId, qrContent]);
  }
  checkQr(accountId, qrContent) {
    return this._transport.request("check_qr", [accountId, qrContent]);
  }
  /**
   * Returns configuration value for the given key.
   */
  getConfig(accountId, key) {
    return this._transport.request("get_config", [accountId, key]);
  }
  batchGetConfig(accountId, keys) {
    return this._transport.request("batch_get_config", [accountId, keys]);
  }
  setStockStrings(strings) {
    return this._transport.request("set_stock_strings", [strings]);
  }
  /**
   * Configures this account with the currently set parameters.
   * Setup the credential config before calling this.
   */
  configure(accountId) {
    return this._transport.request("configure", [accountId]);
  }
  /**
   * Signal an ongoing process to stop.
   */
  stopOngoingProcess(accountId) {
    return this._transport.request("stop_ongoing_process", [accountId]);
  }
  exportSelfKeys(accountId, path, passphrase) {
    return this._transport.request("export_self_keys", [accountId, path, passphrase]);
  }
  importSelfKeys(accountId, path, passphrase) {
    return this._transport.request("import_self_keys", [accountId, path, passphrase]);
  }
  /**
   * Returns the message IDs of all _fresh_ messages of any chat.
   * Typically used for implementing notification summaries
   * or badge counters e.g. on the app icon.
   * The list is already sorted and starts with the most recent fresh message.
   *
   * Messages belonging to muted chats or to the contact requests are not returned;
   * these messages should not be notified
   * and also badge counters should not include these messages.
   *
   * To get the number of fresh messages for a single chat, muted or not,
   * use `get_fresh_msg_cnt()`.
   */
  getFreshMsgs(accountId) {
    return this._transport.request("get_fresh_msgs", [accountId]);
  }
  /**
   * Get the number of _fresh_ messages in a chat.
   * Typically used to implement a badge with a number in the chatlist.
   *
   * If the specified chat is muted,
   * the UI should show the badge counter "less obtrusive",
   * e.g. using "gray" instead of "red" color.
   */
  getFreshMsgCnt(accountId, chatId) {
    return this._transport.request("get_fresh_msg_cnt", [accountId, chatId]);
  }
  /**
   * Gets messages to be processed by the bot and returns their IDs.
   *
   * Only messages with database ID higher than `last_msg_id` config value
   * are returned. After processing the messages, the bot should
   * update `last_msg_id` by calling [`markseen_msgs`]
   * or manually updating the value to avoid getting already
   * processed messages.
   *
   * [`markseen_msgs`]: Self::markseen_msgs
   */
  getNextMsgs(accountId) {
    return this._transport.request("get_next_msgs", [accountId]);
  }
  /**
   * Waits for messages to be processed by the bot and returns their IDs.
   *
   * This function is similar to [`get_next_msgs`],
   * but waits for internal new message notification before returning.
   * New message notification is sent when new message is added to the database,
   * on initialization, when I/O is started and when I/O is stopped.
   * This allows bots to use `wait_next_msgs` in a loop to process
   * old messages after initialization and during the bot runtime.
   * To shutdown the bot, stopping I/O can be used to interrupt
   * pending or next `wait_next_msgs` call.
   *
   * [`get_next_msgs`]: Self::get_next_msgs
   */
  waitNextMsgs(accountId) {
    return this._transport.request("wait_next_msgs", [accountId]);
  }
  /**
   * Estimate the number of messages that will be deleted
   * by the set_config()-options `delete_device_after` or `delete_server_after`.
   * This is typically used to show the estimated impact to the user
   * before actually enabling deletion of old messages.
   */
  estimateAutoDeletionCount(accountId, fromServer, seconds) {
    return this._transport.request("estimate_auto_deletion_count", [accountId, fromServer, seconds]);
  }
  initiateAutocryptKeyTransfer(accountId) {
    return this._transport.request("initiate_autocrypt_key_transfer", [accountId]);
  }
  continueAutocryptKeyTransfer(accountId, messageId, setupCode) {
    return this._transport.request("continue_autocrypt_key_transfer", [accountId, messageId, setupCode]);
  }
  getChatlistEntries(accountId, listFlags, queryString, queryContactId) {
    return this._transport.request("get_chatlist_entries", [accountId, listFlags, queryString, queryContactId]);
  }
  /**
   * Returns chats similar to the given one.
   *
   * Experimental API, subject to change without notice.
   */
  getSimilarChatIds(accountId, chatId) {
    return this._transport.request("get_similar_chat_ids", [accountId, chatId]);
  }
  getChatlistItemsByEntries(accountId, entries) {
    return this._transport.request("get_chatlist_items_by_entries", [accountId, entries]);
  }
  getFullChatById(accountId, chatId) {
    return this._transport.request("get_full_chat_by_id", [accountId, chatId]);
  }
  /**
   * get basic info about a chat,
   * use chatlist_get_full_chat_by_id() instead if you need more information
   */
  getBasicChatInfo(accountId, chatId) {
    return this._transport.request("get_basic_chat_info", [accountId, chatId]);
  }
  acceptChat(accountId, chatId) {
    return this._transport.request("accept_chat", [accountId, chatId]);
  }
  blockChat(accountId, chatId) {
    return this._transport.request("block_chat", [accountId, chatId]);
  }
  /**
   * Delete a chat.
   *
   * Messages are deleted from the device and the chat database entry is deleted.
   * After that, the event #DC_EVENT_MSGS_CHANGED is posted.
   *
   * Things that are _not done_ implicitly:
   *
   * - Messages are **not deleted from the server**.
   * - The chat or the contact is **not blocked**, so new messages from the user/the group may appear as a contact request
   *   and the user may create the chat again.
   * - **Groups are not left** - this would
   *   be unexpected as (1) deleting a normal chat also does not prevent new mails
   *   from arriving, (2) leaving a group requires sending a message to
   *   all group members - especially for groups not used for a longer time, this is
   *   really unexpected when deletion results in contacting all members again,
   *   (3) only leaving groups is also a valid usecase.
   *
   * To leave a chat explicitly, use leave_group()
   */
  deleteChat(accountId, chatId) {
    return this._transport.request("delete_chat", [accountId, chatId]);
  }
  /**
   * Get encryption info for a chat.
   * Get a multi-line encryption info, containing encryption preferences of all members.
   * Can be used to find out why messages sent to group are not encrypted.
   *
   * returns Multi-line text
   */
  getChatEncryptionInfo(accountId, chatId) {
    return this._transport.request("get_chat_encryption_info", [accountId, chatId]);
  }
  /**
   * Get QR code (text and SVG) that will offer an Setup-Contact or Verified-Group invitation.
   * The QR code is compatible to the OPENPGP4FPR format
   * so that a basic fingerprint comparison also works e.g. with OpenKeychain.
   *
   * The scanning device will pass the scanned content to `checkQr()` then;
   * if `checkQr()` returns `askVerifyContact` or `askVerifyGroup`
   * an out-of-band-verification can be joined using `secure_join()`
   *
   * chat_id: If set to a group-chat-id,
   *     the Verified-Group-Invite protocol is offered in the QR code;
   *     works for protected groups as well as for normal groups.
   *     If not set, the Setup-Contact protocol is offered in the QR code.
   *     See https://countermitm.readthedocs.io/en/latest/new.html
   *     for details about both protocols.
   *
   * return format: `[code, svg]`
   */
  getChatSecurejoinQrCodeSvg(accountId, chatId) {
    return this._transport.request("get_chat_securejoin_qr_code_svg", [accountId, chatId]);
  }
  /**
   * Continue a Setup-Contact or Verified-Group-Invite protocol
   * started on another device with `get_chat_securejoin_qr_code_svg()`.
   * This function is typically called when `check_qr()` returns
   * type=AskVerifyContact or type=AskVerifyGroup.
   *
   * The function returns immediately and the handshake runs in background,
   * sending and receiving several messages.
   * During the handshake, info messages are added to the chat,
   * showing progress, success or errors.
   *
   * Subsequent calls of `secure_join()` will abort previous, unfinished handshakes.
   *
   * See https://countermitm.readthedocs.io/en/latest/new.html
   * for details about both protocols.
   *
   * **qr**: The text of the scanned QR code. Typically, the same string as given
   *     to `check_qr()`.
   *
   * **returns**: The chat ID of the joined chat, the UI may redirect to the this chat.
   *         A returned chat ID does not guarantee that the chat is protected or the belonging contact is verified.
   *
   */
  secureJoin(accountId, qr) {
    return this._transport.request("secure_join", [accountId, qr]);
  }
  leaveGroup(accountId, chatId) {
    return this._transport.request("leave_group", [accountId, chatId]);
  }
  /**
   * Remove a member from a group.
   *
   * If the group is already _promoted_ (any message was sent to the group),
   * all group members are informed by a special status message that is sent automatically by this function.
   *
   * Sends out #DC_EVENT_CHAT_MODIFIED and #DC_EVENT_MSGS_CHANGED if a status message was sent.
   */
  removeContactFromChat(accountId, chatId, contactId) {
    return this._transport.request("remove_contact_from_chat", [accountId, chatId, contactId]);
  }
  /**
   * Add a member to a group.
   *
   * If the group is already _promoted_ (any message was sent to the group),
   * all group members are informed by a special status message that is sent automatically by this function.
   *
   * If the group has group protection enabled, only verified contacts can be added to the group.
   *
   * Sends out #DC_EVENT_CHAT_MODIFIED and #DC_EVENT_MSGS_CHANGED if a status message was sent.
   */
  addContactToChat(accountId, chatId, contactId) {
    return this._transport.request("add_contact_to_chat", [accountId, chatId, contactId]);
  }
  /**
   * Get the contact IDs belonging to a chat.
   *
   * - for normal chats, the function always returns exactly one contact,
   *   DC_CONTACT_ID_SELF is returned only for SELF-chats.
   *
   * - for group chats all members are returned, DC_CONTACT_ID_SELF is returned
   *   explicitly as it may happen that oneself gets removed from a still existing
   *   group
   *
   * - for broadcasts, all recipients are returned, DC_CONTACT_ID_SELF is not included
   *
   * - for mailing lists, the behavior is not documented currently, we will decide on that later.
   *   for now, the UI should not show the list for mailing lists.
   *   (we do not know all members and there is not always a global mailing list address,
   *   so we could return only SELF or the known members; this is not decided yet)
   */
  getChatContacts(accountId, chatId) {
    return this._transport.request("get_chat_contacts", [accountId, chatId]);
  }
  /**
   * Create a new group chat.
   *
   * After creation,
   * the group has one member with the ID DC_CONTACT_ID_SELF
   * and is in _unpromoted_ state.
   * This means, you can add or remove members, change the name,
   * the group image and so on without messages being sent to all group members.
   *
   * This changes as soon as the first message is sent to the group members
   * and the group becomes _promoted_.
   * After that, all changes are synced with all group members
   * by sending status message.
   *
   * To check, if a chat is still unpromoted, you can look at the `is_unpromoted` property of `BasicChat` or `FullChat`.
   * This may be useful if you want to show some help for just created groups.
   *
   * @param protect If set to 1 the function creates group with protection initially enabled.
   *     Only verified members are allowed in these groups
   *     and end-to-end-encryption is always enabled.
   */
  createGroupChat(accountId, name, protect) {
    return this._transport.request("create_group_chat", [accountId, name, protect]);
  }
  /**
   * Create a new broadcast list.
   *
   * Broadcast lists are similar to groups on the sending device,
   * however, recipients get the messages in a read-only chat
   * and will see who the other members are.
   *
   * For historical reasons, this function does not take a name directly,
   * instead you have to set the name using dc_set_chat_name()
   * after creating the broadcast list.
   */
  createBroadcastList(accountId) {
    return this._transport.request("create_broadcast_list", [accountId]);
  }
  /**
   * Set group name.
   *
   * If the group is already _promoted_ (any message was sent to the group),
   * all group members are informed by a special status message that is sent automatically by this function.
   *
   * Sends out #DC_EVENT_CHAT_MODIFIED and #DC_EVENT_MSGS_CHANGED if a status message was sent.
   */
  setChatName(accountId, chatId, newName) {
    return this._transport.request("set_chat_name", [accountId, chatId, newName]);
  }
  /**
   * Set group profile image.
   *
   * If the group is already _promoted_ (any message was sent to the group),
   * all group members are informed by a special status message that is sent automatically by this function.
   *
   * Sends out #DC_EVENT_CHAT_MODIFIED and #DC_EVENT_MSGS_CHANGED if a status message was sent.
   *
   * To find out the profile image of a chat, use dc_chat_get_profile_image()
   *
   * @param image_path Full path of the image to use as the group image. The image will immediately be copied to the
   *     `blobdir`; the original image will not be needed anymore.
   *      If you pass null here, the group image is deleted (for promoted groups, all members are informed about
   *      this change anyway).
   */
  setChatProfileImage(accountId, chatId, imagePath) {
    return this._transport.request("set_chat_profile_image", [accountId, chatId, imagePath]);
  }
  setChatVisibility(accountId, chatId, visibility) {
    return this._transport.request("set_chat_visibility", [accountId, chatId, visibility]);
  }
  setChatEphemeralTimer(accountId, chatId, timer) {
    return this._transport.request("set_chat_ephemeral_timer", [accountId, chatId, timer]);
  }
  getChatEphemeralTimer(accountId, chatId) {
    return this._transport.request("get_chat_ephemeral_timer", [accountId, chatId]);
  }
  addDeviceMessage(accountId, label, text) {
    return this._transport.request("add_device_message", [accountId, label, text]);
  }
  /**
   *  Mark all messages in a chat as _noticed_.
   *  _Noticed_ messages are no longer _fresh_ and do not count as being unseen
   *  but are still waiting for being marked as "seen" using markseen_msgs()
   *  (IMAP/MDNs is not done for noticed messages).
   *
   *  Calling this function usually results in the event #DC_EVENT_MSGS_NOTICED.
   *  See also markseen_msgs().
   */
  marknoticedChat(accountId, chatId) {
    return this._transport.request("marknoticed_chat", [accountId, chatId]);
  }
  getFirstUnreadMessageOfChat(accountId, chatId) {
    return this._transport.request("get_first_unread_message_of_chat", [accountId, chatId]);
  }
  /**
   * Set mute duration of a chat.
   *
   * The UI can then call is_chat_muted() when receiving a new message
   * to decide whether it should trigger an notification.
   *
   * Muted chats should not sound or vibrate
   * and should not show a visual notification in the system area.
   * Moreover, muted chats should be excluded from global badge counter
   * (get_fresh_msgs() skips muted chats therefore)
   * and the in-app, per-chat badge counter should use a less obtrusive color.
   *
   * Sends out #DC_EVENT_CHAT_MODIFIED.
   */
  setChatMuteDuration(accountId, chatId, duration) {
    return this._transport.request("set_chat_mute_duration", [accountId, chatId, duration]);
  }
  /**
   * Check whether the chat is currently muted (can be changed by set_chat_mute_duration()).
   *
   * This is available as a standalone function outside of fullchat, because it might be only needed for notification
   */
  isChatMuted(accountId, chatId) {
    return this._transport.request("is_chat_muted", [accountId, chatId]);
  }
  /**
   * Mark messages as presented to the user.
   * Typically, UIs call this function on scrolling through the message list,
   * when the messages are presented at least for a little moment.
   * The concrete action depends on the type of the chat and on the users settings
   * (dc_msgs_presented() may be a better name therefore, but well. :)
   *
   * - For normal chats, the IMAP state is updated, MDN is sent
   *   (if set_config()-options `mdns_enabled` is set)
   *   and the internal state is changed to @ref DC_STATE_IN_SEEN to reflect these actions.
   *
   * - For contact requests, no IMAP or MDNs is done
   *   and the internal state is not changed therefore.
   *   See also marknoticed_chat().
   *
   * Moreover, timer is started for incoming ephemeral messages.
   * This also happens for contact requests chats.
   *
   * This function updates `last_msg_id` configuration value
   * to the maximum of the current value and IDs passed to this function.
   * Bots which mark messages as seen can rely on this side effect
   * to avoid updating `last_msg_id` value manually.
   *
   * One #DC_EVENT_MSGS_NOTICED event is emitted per modified chat.
   */
  markseenMsgs(accountId, msgIds) {
    return this._transport.request("markseen_msgs", [accountId, msgIds]);
  }
  getMessageIds(accountId, chatId, infoOnly, addDaymarker) {
    return this._transport.request("get_message_ids", [accountId, chatId, infoOnly, addDaymarker]);
  }
  getMessageListItems(accountId, chatId, infoOnly, addDaymarker) {
    return this._transport.request("get_message_list_items", [accountId, chatId, infoOnly, addDaymarker]);
  }
  getMessage(accountId, messageId) {
    return this._transport.request("get_message", [accountId, messageId]);
  }
  getMessageHtml(accountId, messageId) {
    return this._transport.request("get_message_html", [accountId, messageId]);
  }
  /**
   * get multiple messages in one call,
   * if loading one message fails the error is stored in the result object in it's place.
   *
   * this is the batch variant of [get_message]
   */
  getMessages(accountId, messageIds) {
    return this._transport.request("get_messages", [accountId, messageIds]);
  }
  /**
   * Fetch info desktop needs for creating a notification for a message
   */
  getMessageNotificationInfo(accountId, messageId) {
    return this._transport.request("get_message_notification_info", [accountId, messageId]);
  }
  /**
   * Delete messages. The messages are deleted on the current device and
   * on the IMAP server.
   */
  deleteMessages(accountId, messageIds) {
    return this._transport.request("delete_messages", [accountId, messageIds]);
  }
  /**
   * Get an informational text for a single message. The text is multiline and may
   * contain e.g. the raw text of the message.
   *
   * The max. text returned is typically longer (about 100000 characters) than the
   * max. text returned by dc_msg_get_text() (about 30000 characters).
   */
  getMessageInfo(accountId, messageId) {
    return this._transport.request("get_message_info", [accountId, messageId]);
  }
  /**
   * Returns additional information for single message.
   */
  getMessageInfoObject(accountId, messageId) {
    return this._transport.request("get_message_info_object", [accountId, messageId]);
  }
  /**
   * Returns contacts that sent read receipts and the time of reading.
   */
  getMessageReadReceipts(accountId, messageId) {
    return this._transport.request("get_message_read_receipts", [accountId, messageId]);
  }
  /**
   * Asks the core to start downloading a message fully.
   * This function is typically called when the user hits the "Download" button
   * that is shown by the UI in case `download_state` is `'Available'` or `'Failure'`
   *
   * On success, the @ref DC_MSG "view type of the message" may change
   * or the message may be replaced completely by one or more messages with other message IDs.
   * That may happen e.g. in cases where the message was encrypted
   * and the type could not be determined without fully downloading.
   * Downloaded content can be accessed as usual after download.
   *
   * To reflect these changes a @ref DC_EVENT_MSGS_CHANGED event will be emitted.
   */
  downloadFullMessage(accountId, messageId) {
    return this._transport.request("download_full_message", [accountId, messageId]);
  }
  /**
   * Search messages containing the given query string.
   * Searching can be done globally (chat_id=None) or in a specified chat only (chat_id set).
   *
   * Global search results are typically displayed using dc_msg_get_summary(), chat
   * search results may just highlight the corresponding messages and present a
   * prev/next button.
   *
   * For the global search, the result is limited to 1000 messages,
   * this allows an incremental search done fast.
   * So, when getting exactly 1000 messages, the result actually may be truncated;
   * the UIs may display sth. like "1000+ messages found" in this case.
   * The chat search (if chat_id is set) is not limited.
   */
  searchMessages(accountId, query, chatId) {
    return this._transport.request("search_messages", [accountId, query, chatId]);
  }
  messageIdsToSearchResults(accountId, messageIds) {
    return this._transport.request("message_ids_to_search_results", [accountId, messageIds]);
  }
  /**
   * Get a single contact options by ID.
   */
  getContact(accountId, contactId) {
    return this._transport.request("get_contact", [accountId, contactId]);
  }
  /**
   * Add a single contact as a result of an explicit user action.
   *
   * Returns contact id of the created or existing contact
   */
  createContact(accountId, email, name) {
    return this._transport.request("create_contact", [accountId, email, name]);
  }
  /**
   * Returns contact id of the created or existing DM chat with that contact
   */
  createChatByContactId(accountId, contactId) {
    return this._transport.request("create_chat_by_contact_id", [accountId, contactId]);
  }
  blockContact(accountId, contactId) {
    return this._transport.request("block_contact", [accountId, contactId]);
  }
  unblockContact(accountId, contactId) {
    return this._transport.request("unblock_contact", [accountId, contactId]);
  }
  getBlockedContacts(accountId) {
    return this._transport.request("get_blocked_contacts", [accountId]);
  }
  getContactIds(accountId, listFlags, query) {
    return this._transport.request("get_contact_ids", [accountId, listFlags, query]);
  }
  /**
   * Get a list of contacts.
   * (formerly called getContacts2 in desktop)
   */
  getContacts(accountId, listFlags, query) {
    return this._transport.request("get_contacts", [accountId, listFlags, query]);
  }
  getContactsByIds(accountId, ids) {
    return this._transport.request("get_contacts_by_ids", [accountId, ids]);
  }
  deleteContact(accountId, contactId) {
    return this._transport.request("delete_contact", [accountId, contactId]);
  }
  changeContactName(accountId, contactId, name) {
    return this._transport.request("change_contact_name", [accountId, contactId, name]);
  }
  /**
   * Get encryption info for a contact.
   * Get a multi-line encryption info, containing your fingerprint and the
   * fingerprint of the contact, used e.g. to compare the fingerprints for a simple out-of-band verification.
   */
  getContactEncryptionInfo(accountId, contactId) {
    return this._transport.request("get_contact_encryption_info", [accountId, contactId]);
  }
  /**
   * Check if an e-mail address belongs to a known and unblocked contact.
   * To get a list of all known and unblocked contacts, use contacts_get_contacts().
   *
   * To validate an e-mail address independently of the contact database
   * use check_email_validity().
   */
  lookupContactIdByAddr(accountId, addr) {
    return this._transport.request("lookup_contact_id_by_addr", [accountId, addr]);
  }
  /**
   * Returns the [`ChatId`] for the 1:1 chat with `contact_id` if it exists.
   *
   * If it does not exist, `None` is returned.
   */
  getChatIdByContactId(accountId, contactId) {
    return this._transport.request("get_chat_id_by_contact_id", [accountId, contactId]);
  }
  /**
   * Returns all message IDs of the given types in a chat.
   * Typically used to show a gallery.
   *
   * The list is already sorted and starts with the oldest message.
   * Clients should not try to re-sort the list as this would be an expensive action
   * and would result in inconsistencies between clients.
   *
   * Setting `chat_id` to `None` (`null` in typescript) means get messages with media
   * from any chat of the currently used account.
   */
  getChatMedia(accountId, chatId, messageType, orMessageType2, orMessageType3) {
    return this._transport.request("get_chat_media", [accountId, chatId, messageType, orMessageType2, orMessageType3]);
  }
  /**
   * Search next/previous message based on a given message and a list of types.
   * Typically used to implement the "next" and "previous" buttons
   * in a gallery or in a media player.
   *
   * one combined call for getting chat::get_next_media for both directions
   * the manual chat::get_next_media in only one direction is not exposed by the jsonrpc yet
   *
   * Deprecated 2023-10-03, use `get_chat_media` method
   * and navigate the returned array instead.
   */
  getNeighboringChatMedia(accountId, msgId, messageType, orMessageType2, orMessageType3) {
    return this._transport.request("get_neighboring_chat_media", [accountId, msgId, messageType, orMessageType2, orMessageType3]);
  }
  exportBackup(accountId, destination, passphrase) {
    return this._transport.request("export_backup", [accountId, destination, passphrase]);
  }
  importBackup(accountId, path, passphrase) {
    return this._transport.request("import_backup", [accountId, path, passphrase]);
  }
  /**
   * Offers a backup for remote devices to retrieve.
   *
   * Can be cancelled by stopping the ongoing process.  Success or failure can be tracked
   * via the `ImexProgress` event which should either reach `1000` for success or `0` for
   * failure.
   *
   * This **stops IO** while it is running.
   *
   * Returns once a remote device has retrieved the backup, or is cancelled.
   */
  provideBackup(accountId) {
    return this._transport.request("provide_backup", [accountId]);
  }
  /**
   * Returns the text of the QR code for the running [`CommandApi::provide_backup`].
   *
   * This QR code text can be used in [`CommandApi::get_backup`] on a second device to
   * retrieve the backup and setup this second device.
   *
   * This call will fail if there is currently no concurrent call to
   * [`CommandApi::provide_backup`].  This call may block if the QR code is not yet
   * ready.
   */
  getBackupQr(accountId) {
    return this._transport.request("get_backup_qr", [accountId]);
  }
  /**
   * Returns the rendered QR code for the running [`CommandApi::provide_backup`].
   *
   * This QR code can be used in [`CommandApi::get_backup`] on a second device to
   * retrieve the backup and setup this second device.
   *
   * This call will fail if there is currently no concurrent call to
   * [`CommandApi::provide_backup`].  This call may block if the QR code is not yet
   * ready.
   *
   * Returns the QR code rendered as an SVG image.
   */
  getBackupQrSvg(accountId) {
    return this._transport.request("get_backup_qr_svg", [accountId]);
  }
  /**
   * Gets a backup from a remote provider.
   *
   * This retrieves the backup from a remote device over the network and imports it into
   * the current device.
   *
   * Can be cancelled by stopping the ongoing process.
   */
  getBackup(accountId, qrText) {
    return this._transport.request("get_backup", [accountId, qrText]);
  }
  /**
   * Indicate that the network likely has come back.
   * or just that the network conditions might have changed
   */
  maybeNetwork() {
    return this._transport.request("maybe_network", []);
  }
  /**
   * Get the current connectivity, i.e. whether the device is connected to the IMAP server.
   * One of:
   * - DC_CONNECTIVITY_NOT_CONNECTED (1000-1999): Show e.g. the string "Not connected" or a red dot
   * - DC_CONNECTIVITY_CONNECTING (2000-2999): Show e.g. the string "Connecting…" or a yellow dot
   * - DC_CONNECTIVITY_WORKING (3000-3999): Show e.g. the string "Getting new messages" or a spinning wheel
   * - DC_CONNECTIVITY_CONNECTED (>=4000): Show e.g. the string "Connected" or a green dot
   *
   * We don't use exact values but ranges here so that we can split up
   * states into multiple states in the future.
   *
   * Meant as a rough overview that can be shown
   * e.g. in the title of the main screen.
   *
   * If the connectivity changes, a #DC_EVENT_CONNECTIVITY_CHANGED will be emitted.
   */
  getConnectivity(accountId) {
    return this._transport.request("get_connectivity", [accountId]);
  }
  /**
   * Get an overview of the current connectivity, and possibly more statistics.
   * Meant to give the user more insight about the current status than
   * the basic connectivity info returned by get_connectivity(); show this
   * e.g., if the user taps on said basic connectivity info.
   *
   * If this page changes, a #DC_EVENT_CONNECTIVITY_CHANGED will be emitted.
   *
   * This comes as an HTML from the core so that we can easily improve it
   * and the improvement instantly reaches all UIs.
   */
  getConnectivityHtml(accountId) {
    return this._transport.request("get_connectivity_html", [accountId]);
  }
  getLocations(accountId, chatId, contactId, timestampBegin, timestampEnd) {
    return this._transport.request("get_locations", [accountId, chatId, contactId, timestampBegin, timestampEnd]);
  }
  sendWebxdcStatusUpdate(accountId, instanceMsgId, updateStr, description) {
    return this._transport.request("send_webxdc_status_update", [accountId, instanceMsgId, updateStr, description]);
  }
  getWebxdcStatusUpdates(accountId, instanceMsgId, lastKnownSerial) {
    return this._transport.request("get_webxdc_status_updates", [accountId, instanceMsgId, lastKnownSerial]);
  }
  /**
   * Get info from a webxdc message
   */
  getWebxdcInfo(accountId, instanceMsgId) {
    return this._transport.request("get_webxdc_info", [accountId, instanceMsgId]);
  }
  /**
   * Get blob encoded as base64 from a webxdc message
   *
   * path is the path of the file within webxdc archive
   */
  getWebxdcBlob(accountId, instanceMsgId, path) {
    return this._transport.request("get_webxdc_blob", [accountId, instanceMsgId, path]);
  }
  /**
   * Makes an HTTP GET request and returns a response.
   *
   * `url` is the HTTP or HTTPS URL.
   */
  getHttpResponse(accountId, url) {
    return this._transport.request("get_http_response", [accountId, url]);
  }
  /**
   * Forward messages to another chat.
   *
   * All types of messages can be forwarded,
   * however, they will be flagged as such (dc_msg_is_forwarded() is set).
   *
   * Original sender, info-state and webxdc updates are not forwarded on purpose.
   */
  forwardMessages(accountId, messageIds, chatId) {
    return this._transport.request("forward_messages", [accountId, messageIds, chatId]);
  }
  /**
   * Resend messages and make information available for newly added chat members.
   * Resending sends out the original message, however, recipients and webxdc-status may differ.
   * Clients that already have the original message can still ignore the resent message as
   * they have tracked the state by dedicated updates.
   *
   * Some messages cannot be resent, eg. info-messages, drafts, already pending messages or messages that are not sent by SELF.
   *
   * message_ids all message IDs that should be resend. All messages must belong to the same chat.
   */
  resendMessages(accountId, messageIds) {
    return this._transport.request("resend_messages", [accountId, messageIds]);
  }
  sendSticker(accountId, chatId, stickerPath) {
    return this._transport.request("send_sticker", [accountId, chatId, stickerPath]);
  }
  /**
   * Send a reaction to message.
   *
   * Reaction is a string of emojis separated by spaces. Reaction to a
   * single message can be sent multiple times. The last reaction
   * received overrides all previously received reactions. It is
   * possible to remove all reactions by sending an empty string.
   */
  sendReaction(accountId, messageId, reaction) {
    return this._transport.request("send_reaction", [accountId, messageId, reaction]);
  }
  /**
   * Returns reactions to the message.
   */
  getMessageReactions(accountId, messageId) {
    return this._transport.request("get_message_reactions", [accountId, messageId]);
  }
  sendMsg(accountId, chatId, data) {
    return this._transport.request("send_msg", [accountId, chatId, data]);
  }
  /**
   * Checks if messages can be sent to a given chat.
   */
  canSend(accountId, chatId) {
    return this._transport.request("can_send", [accountId, chatId]);
  }
  removeDraft(accountId, chatId) {
    return this._transport.request("remove_draft", [accountId, chatId]);
  }
  /**
   *  Get draft for a chat, if any.
   */
  getDraft(accountId, chatId) {
    return this._transport.request("get_draft", [accountId, chatId]);
  }
  sendVideochatInvitation(accountId, chatId) {
    return this._transport.request("send_videochat_invitation", [accountId, chatId]);
  }
  miscGetStickerFolder(accountId) {
    return this._transport.request("misc_get_sticker_folder", [accountId]);
  }
  /**
   * Saves a sticker to a collection/folder in the account's sticker folder.
   */
  miscSaveSticker(accountId, msgId, collection) {
    return this._transport.request("misc_save_sticker", [accountId, msgId, collection]);
  }
  /**
   * for desktop, get stickers from stickers folder,
   * grouped by the collection/folder they are in.
   */
  miscGetStickers(accountId) {
    return this._transport.request("misc_get_stickers", [accountId]);
  }
  /**
   * Returns the messageid of the sent message
   */
  miscSendTextMessage(accountId, chatId, text) {
    return this._transport.request("misc_send_text_message", [accountId, chatId, text]);
  }
  miscSendMsg(accountId, chatId, text, file, location, quotedMessageId) {
    return this._transport.request("misc_send_msg", [accountId, chatId, text, file, location, quotedMessageId]);
  }
  miscSetDraft(accountId, chatId, text, file, quotedMessageId, viewType) {
    return this._transport.request("misc_set_draft", [accountId, chatId, text, file, quotedMessageId, viewType]);
  }
  miscSendDraft(accountId, chatId) {
    return this._transport.request("misc_send_draft", [accountId, chatId]);
  }
};

// dist/src/client.js
var import_yerpc = require("yerpc");
var import_tiny_emitter = require("@deltachat/tiny-emitter");
var BaseDeltaChat = class extends import_tiny_emitter.TinyEmitter {
  constructor(transport, startEventLoop) {
    super();
    this.transport = transport;
    this.contextEmitters = {};
    this.rpc = new RawClient(this.transport);
    if (startEventLoop) {
      this.eventTask = this.eventLoop();
    }
  }
  async eventLoop() {
    while (true) {
      const event = await this.rpc.getNextEvent();
      this.emit(event.event.kind, event.contextId, event.event);
      this.emit("ALL", event.contextId, event.event);
      if (this.contextEmitters[event.contextId]) {
        this.contextEmitters[event.contextId].emit(
          event.event.kind,
          //@ts-ignore
          event.event
        );
        this.contextEmitters[event.contextId].emit("ALL", event.event);
      }
    }
  }
  async listAccounts() {
    return await this.rpc.getAllAccounts();
  }
  getContextEvents(account_id) {
    if (this.contextEmitters[account_id]) {
      return this.contextEmitters[account_id];
    } else {
      this.contextEmitters[account_id] = new import_tiny_emitter.TinyEmitter();
      return this.contextEmitters[account_id];
    }
  }
};
var DEFAULT_OPTS = {
  url: "ws://localhost:20808/ws",
  startEventLoop: true
};
var DeltaChat = class extends BaseDeltaChat {
  close() {
    this.transport.close();
  }
  constructor(opts) {
    if (typeof opts === "string") {
      opts = Object.assign(Object.assign({}, DEFAULT_OPTS), { url: opts });
    } else if (opts) {
      opts = Object.assign(Object.assign({}, DEFAULT_OPTS), opts);
    } else {
      opts = Object.assign({}, DEFAULT_OPTS);
    }
    const transport = new import_yerpc.WebsocketTransport(opts.url);
    super(transport, opts.startEventLoop);
    this.opts = opts;
  }
};
var StdioDeltaChat = class extends BaseDeltaChat {
  close() {
  }
  constructor(input, output, startEventLoop) {
    const transport = new StdioTransport(input, output);
    super(transport, startEventLoop);
  }
};
var StdioTransport = class extends import_yerpc.BaseTransport {
  constructor(input, output) {
    super();
    this.input = input;
    this.output = output;
    var buffer = "";
    this.output.on("data", (data) => {
      buffer += data.toString();
      while (buffer.includes("\n")) {
        const n = buffer.indexOf("\n");
        const line = buffer.substring(0, n);
        const message = JSON.parse(line);
        this._onmessage(message);
        buffer = buffer.substring(n + 1);
      }
    });
  }
  _send(message) {
    const serialized = JSON.stringify(message);
    this.input.write(serialized + "\n");
  }
};

// dist/src/lib.js
var yerpc = __toESM(require("yerpc"), 1);

// dist/generated/constants.js
var C;
(function(C2) {
  C2[C2["DC_CERTCK_ACCEPT_INVALID_CERTIFICATES"] = 3] = "DC_CERTCK_ACCEPT_INVALID_CERTIFICATES";
  C2[C2["DC_CERTCK_AUTO"] = 0] = "DC_CERTCK_AUTO";
  C2[C2["DC_CERTCK_STRICT"] = 1] = "DC_CERTCK_STRICT";
  C2[C2["DC_CHAT_ID_ALLDONE_HINT"] = 7] = "DC_CHAT_ID_ALLDONE_HINT";
  C2[C2["DC_CHAT_ID_ARCHIVED_LINK"] = 6] = "DC_CHAT_ID_ARCHIVED_LINK";
  C2[C2["DC_CHAT_ID_LAST_SPECIAL"] = 9] = "DC_CHAT_ID_LAST_SPECIAL";
  C2[C2["DC_CHAT_ID_TRASH"] = 3] = "DC_CHAT_ID_TRASH";
  C2[C2["DC_CHAT_TYPE_BROADCAST"] = 160] = "DC_CHAT_TYPE_BROADCAST";
  C2[C2["DC_CHAT_TYPE_GROUP"] = 120] = "DC_CHAT_TYPE_GROUP";
  C2[C2["DC_CHAT_TYPE_MAILINGLIST"] = 140] = "DC_CHAT_TYPE_MAILINGLIST";
  C2[C2["DC_CHAT_TYPE_SINGLE"] = 100] = "DC_CHAT_TYPE_SINGLE";
  C2[C2["DC_CHAT_TYPE_UNDEFINED"] = 0] = "DC_CHAT_TYPE_UNDEFINED";
  C2[C2["DC_CONNECTIVITY_CONNECTED"] = 4e3] = "DC_CONNECTIVITY_CONNECTED";
  C2[C2["DC_CONNECTIVITY_CONNECTING"] = 2e3] = "DC_CONNECTIVITY_CONNECTING";
  C2[C2["DC_CONNECTIVITY_NOT_CONNECTED"] = 1e3] = "DC_CONNECTIVITY_NOT_CONNECTED";
  C2[C2["DC_CONNECTIVITY_WORKING"] = 3e3] = "DC_CONNECTIVITY_WORKING";
  C2[C2["DC_CONTACT_ID_DEVICE"] = 5] = "DC_CONTACT_ID_DEVICE";
  C2[C2["DC_CONTACT_ID_INFO"] = 2] = "DC_CONTACT_ID_INFO";
  C2[C2["DC_CONTACT_ID_LAST_SPECIAL"] = 9] = "DC_CONTACT_ID_LAST_SPECIAL";
  C2[C2["DC_CONTACT_ID_SELF"] = 1] = "DC_CONTACT_ID_SELF";
  C2[C2["DC_GCL_ADD_ALLDONE_HINT"] = 4] = "DC_GCL_ADD_ALLDONE_HINT";
  C2[C2["DC_GCL_ADD_SELF"] = 2] = "DC_GCL_ADD_SELF";
  C2[C2["DC_GCL_ARCHIVED_ONLY"] = 1] = "DC_GCL_ARCHIVED_ONLY";
  C2[C2["DC_GCL_FOR_FORWARDING"] = 8] = "DC_GCL_FOR_FORWARDING";
  C2[C2["DC_GCL_NO_SPECIALS"] = 2] = "DC_GCL_NO_SPECIALS";
  C2[C2["DC_GCL_VERIFIED_ONLY"] = 1] = "DC_GCL_VERIFIED_ONLY";
  C2[C2["DC_GCM_ADDDAYMARKER"] = 1] = "DC_GCM_ADDDAYMARKER";
  C2[C2["DC_GCM_INFO_ONLY"] = 2] = "DC_GCM_INFO_ONLY";
  C2[C2["DC_KEY_GEN_DEFAULT"] = 0] = "DC_KEY_GEN_DEFAULT";
  C2[C2["DC_KEY_GEN_ED25519"] = 2] = "DC_KEY_GEN_ED25519";
  C2[C2["DC_KEY_GEN_RSA2048"] = 1] = "DC_KEY_GEN_RSA2048";
  C2[C2["DC_KEY_GEN_RSA4096"] = 3] = "DC_KEY_GEN_RSA4096";
  C2[C2["DC_LP_AUTH_NORMAL"] = 4] = "DC_LP_AUTH_NORMAL";
  C2[C2["DC_LP_AUTH_OAUTH2"] = 2] = "DC_LP_AUTH_OAUTH2";
  C2[C2["DC_MEDIA_QUALITY_BALANCED"] = 0] = "DC_MEDIA_QUALITY_BALANCED";
  C2[C2["DC_MEDIA_QUALITY_WORSE"] = 1] = "DC_MEDIA_QUALITY_WORSE";
  C2[C2["DC_MSG_ID_DAYMARKER"] = 9] = "DC_MSG_ID_DAYMARKER";
  C2[C2["DC_MSG_ID_LAST_SPECIAL"] = 9] = "DC_MSG_ID_LAST_SPECIAL";
  C2[C2["DC_MSG_ID_MARKER1"] = 1] = "DC_MSG_ID_MARKER1";
  C2[C2["DC_PROVIDER_STATUS_BROKEN"] = 3] = "DC_PROVIDER_STATUS_BROKEN";
  C2[C2["DC_PROVIDER_STATUS_OK"] = 1] = "DC_PROVIDER_STATUS_OK";
  C2[C2["DC_PROVIDER_STATUS_PREPARATION"] = 2] = "DC_PROVIDER_STATUS_PREPARATION";
  C2[C2["DC_SHOW_EMAILS_ACCEPTED_CONTACTS"] = 1] = "DC_SHOW_EMAILS_ACCEPTED_CONTACTS";
  C2[C2["DC_SHOW_EMAILS_ALL"] = 2] = "DC_SHOW_EMAILS_ALL";
  C2[C2["DC_SHOW_EMAILS_OFF"] = 0] = "DC_SHOW_EMAILS_OFF";
  C2[C2["DC_SOCKET_AUTO"] = 0] = "DC_SOCKET_AUTO";
  C2[C2["DC_SOCKET_PLAIN"] = 3] = "DC_SOCKET_PLAIN";
  C2[C2["DC_SOCKET_SSL"] = 1] = "DC_SOCKET_SSL";
  C2[C2["DC_SOCKET_STARTTLS"] = 2] = "DC_SOCKET_STARTTLS";
  C2[C2["DC_STATE_IN_FRESH"] = 10] = "DC_STATE_IN_FRESH";
  C2[C2["DC_STATE_IN_NOTICED"] = 13] = "DC_STATE_IN_NOTICED";
  C2[C2["DC_STATE_IN_SEEN"] = 16] = "DC_STATE_IN_SEEN";
  C2[C2["DC_STATE_OUT_DELIVERED"] = 26] = "DC_STATE_OUT_DELIVERED";
  C2[C2["DC_STATE_OUT_DRAFT"] = 19] = "DC_STATE_OUT_DRAFT";
  C2[C2["DC_STATE_OUT_FAILED"] = 24] = "DC_STATE_OUT_FAILED";
  C2[C2["DC_STATE_OUT_MDN_RCVD"] = 28] = "DC_STATE_OUT_MDN_RCVD";
  C2[C2["DC_STATE_OUT_PENDING"] = 20] = "DC_STATE_OUT_PENDING";
  C2[C2["DC_STATE_OUT_PREPARING"] = 18] = "DC_STATE_OUT_PREPARING";
  C2[C2["DC_STATE_UNDEFINED"] = 0] = "DC_STATE_UNDEFINED";
  C2[C2["DC_STR_AC_SETUP_MSG_BODY"] = 43] = "DC_STR_AC_SETUP_MSG_BODY";
  C2[C2["DC_STR_AC_SETUP_MSG_SUBJECT"] = 42] = "DC_STR_AC_SETUP_MSG_SUBJECT";
  C2[C2["DC_STR_ADD_MEMBER_BY_OTHER"] = 129] = "DC_STR_ADD_MEMBER_BY_OTHER";
  C2[C2["DC_STR_ADD_MEMBER_BY_YOU"] = 128] = "DC_STR_ADD_MEMBER_BY_YOU";
  C2[C2["DC_STR_AEAP_ADDR_CHANGED"] = 122] = "DC_STR_AEAP_ADDR_CHANGED";
  C2[C2["DC_STR_AEAP_EXPLANATION_AND_LINK"] = 123] = "DC_STR_AEAP_EXPLANATION_AND_LINK";
  C2[C2["DC_STR_ARCHIVEDCHATS"] = 40] = "DC_STR_ARCHIVEDCHATS";
  C2[C2["DC_STR_AUDIO"] = 11] = "DC_STR_AUDIO";
  C2[C2["DC_STR_BACKUP_TRANSFER_MSG_BODY"] = 163] = "DC_STR_BACKUP_TRANSFER_MSG_BODY";
  C2[C2["DC_STR_BACKUP_TRANSFER_QR"] = 162] = "DC_STR_BACKUP_TRANSFER_QR";
  C2[C2["DC_STR_BAD_TIME_MSG_BODY"] = 85] = "DC_STR_BAD_TIME_MSG_BODY";
  C2[C2["DC_STR_BROADCAST_LIST"] = 115] = "DC_STR_BROADCAST_LIST";
  C2[C2["DC_STR_CANNOT_LOGIN"] = 60] = "DC_STR_CANNOT_LOGIN";
  C2[C2["DC_STR_CANTDECRYPT_MSG_BODY"] = 29] = "DC_STR_CANTDECRYPT_MSG_BODY";
  C2[C2["DC_STR_CHAT_PROTECTION_DISABLED"] = 171] = "DC_STR_CHAT_PROTECTION_DISABLED";
  C2[C2["DC_STR_CHAT_PROTECTION_ENABLED"] = 170] = "DC_STR_CHAT_PROTECTION_ENABLED";
  C2[C2["DC_STR_CONFIGURATION_FAILED"] = 84] = "DC_STR_CONFIGURATION_FAILED";
  C2[C2["DC_STR_CONNECTED"] = 107] = "DC_STR_CONNECTED";
  C2[C2["DC_STR_CONNTECTING"] = 108] = "DC_STR_CONNTECTING";
  C2[C2["DC_STR_CONTACT_NOT_VERIFIED"] = 36] = "DC_STR_CONTACT_NOT_VERIFIED";
  C2[C2["DC_STR_CONTACT_SETUP_CHANGED"] = 37] = "DC_STR_CONTACT_SETUP_CHANGED";
  C2[C2["DC_STR_CONTACT_VERIFIED"] = 35] = "DC_STR_CONTACT_VERIFIED";
  C2[C2["DC_STR_DEVICE_MESSAGES"] = 68] = "DC_STR_DEVICE_MESSAGES";
  C2[C2["DC_STR_DEVICE_MESSAGES_HINT"] = 70] = "DC_STR_DEVICE_MESSAGES_HINT";
  C2[C2["DC_STR_DOWNLOAD_AVAILABILITY"] = 100] = "DC_STR_DOWNLOAD_AVAILABILITY";
  C2[C2["DC_STR_DRAFT"] = 3] = "DC_STR_DRAFT";
  C2[C2["DC_STR_E2E_AVAILABLE"] = 25] = "DC_STR_E2E_AVAILABLE";
  C2[C2["DC_STR_E2E_PREFERRED"] = 34] = "DC_STR_E2E_PREFERRED";
  C2[C2["DC_STR_ENCRYPTEDMSG"] = 24] = "DC_STR_ENCRYPTEDMSG";
  C2[C2["DC_STR_ENCR_NONE"] = 28] = "DC_STR_ENCR_NONE";
  C2[C2["DC_STR_ENCR_TRANSP"] = 27] = "DC_STR_ENCR_TRANSP";
  C2[C2["DC_STR_EPHEMERAL_DAY"] = 79] = "DC_STR_EPHEMERAL_DAY";
  C2[C2["DC_STR_EPHEMERAL_DAYS"] = 95] = "DC_STR_EPHEMERAL_DAYS";
  C2[C2["DC_STR_EPHEMERAL_DISABLED"] = 75] = "DC_STR_EPHEMERAL_DISABLED";
  C2[C2["DC_STR_EPHEMERAL_FOUR_WEEKS"] = 81] = "DC_STR_EPHEMERAL_FOUR_WEEKS";
  C2[C2["DC_STR_EPHEMERAL_HOUR"] = 78] = "DC_STR_EPHEMERAL_HOUR";
  C2[C2["DC_STR_EPHEMERAL_HOURS"] = 94] = "DC_STR_EPHEMERAL_HOURS";
  C2[C2["DC_STR_EPHEMERAL_MINUTE"] = 77] = "DC_STR_EPHEMERAL_MINUTE";
  C2[C2["DC_STR_EPHEMERAL_MINUTES"] = 93] = "DC_STR_EPHEMERAL_MINUTES";
  C2[C2["DC_STR_EPHEMERAL_SECONDS"] = 76] = "DC_STR_EPHEMERAL_SECONDS";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_DAY_BY_OTHER"] = 147] = "DC_STR_EPHEMERAL_TIMER_1_DAY_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_DAY_BY_YOU"] = 146] = "DC_STR_EPHEMERAL_TIMER_1_DAY_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_HOUR_BY_OTHER"] = 145] = "DC_STR_EPHEMERAL_TIMER_1_HOUR_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_HOUR_BY_YOU"] = 144] = "DC_STR_EPHEMERAL_TIMER_1_HOUR_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_MINUTE_BY_OTHER"] = 143] = "DC_STR_EPHEMERAL_TIMER_1_MINUTE_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_MINUTE_BY_YOU"] = 142] = "DC_STR_EPHEMERAL_TIMER_1_MINUTE_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_WEEK_BY_OTHER"] = 149] = "DC_STR_EPHEMERAL_TIMER_1_WEEK_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_1_WEEK_BY_YOU"] = 148] = "DC_STR_EPHEMERAL_TIMER_1_WEEK_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_DAYS_BY_OTHER"] = 155] = "DC_STR_EPHEMERAL_TIMER_DAYS_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_DAYS_BY_YOU"] = 154] = "DC_STR_EPHEMERAL_TIMER_DAYS_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_DISABLED_BY_OTHER"] = 139] = "DC_STR_EPHEMERAL_TIMER_DISABLED_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_DISABLED_BY_YOU"] = 138] = "DC_STR_EPHEMERAL_TIMER_DISABLED_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_HOURS_BY_OTHER"] = 153] = "DC_STR_EPHEMERAL_TIMER_HOURS_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_HOURS_BY_YOU"] = 152] = "DC_STR_EPHEMERAL_TIMER_HOURS_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_MINUTES_BY_OTHER"] = 151] = "DC_STR_EPHEMERAL_TIMER_MINUTES_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_MINUTES_BY_YOU"] = 150] = "DC_STR_EPHEMERAL_TIMER_MINUTES_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_SECONDS_BY_OTHER"] = 141] = "DC_STR_EPHEMERAL_TIMER_SECONDS_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_SECONDS_BY_YOU"] = 140] = "DC_STR_EPHEMERAL_TIMER_SECONDS_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_TIMER_WEEKS_BY_OTHER"] = 157] = "DC_STR_EPHEMERAL_TIMER_WEEKS_BY_OTHER";
  C2[C2["DC_STR_EPHEMERAL_TIMER_WEEKS_BY_YOU"] = 156] = "DC_STR_EPHEMERAL_TIMER_WEEKS_BY_YOU";
  C2[C2["DC_STR_EPHEMERAL_WEEK"] = 80] = "DC_STR_EPHEMERAL_WEEK";
  C2[C2["DC_STR_EPHEMERAL_WEEKS"] = 96] = "DC_STR_EPHEMERAL_WEEKS";
  C2[C2["DC_STR_ERROR"] = 112] = "DC_STR_ERROR";
  C2[C2["DC_STR_ERROR_NO_NETWORK"] = 87] = "DC_STR_ERROR_NO_NETWORK";
  C2[C2["DC_STR_FAILED_SENDING_TO"] = 74] = "DC_STR_FAILED_SENDING_TO";
  C2[C2["DC_STR_FILE"] = 12] = "DC_STR_FILE";
  C2[C2["DC_STR_FINGERPRINTS"] = 30] = "DC_STR_FINGERPRINTS";
  C2[C2["DC_STR_FORWARDED"] = 97] = "DC_STR_FORWARDED";
  C2[C2["DC_STR_GIF"] = 23] = "DC_STR_GIF";
  C2[C2["DC_STR_GROUP_IMAGE_CHANGED_BY_OTHER"] = 127] = "DC_STR_GROUP_IMAGE_CHANGED_BY_OTHER";
  C2[C2["DC_STR_GROUP_IMAGE_CHANGED_BY_YOU"] = 126] = "DC_STR_GROUP_IMAGE_CHANGED_BY_YOU";
  C2[C2["DC_STR_GROUP_IMAGE_DELETED_BY_OTHER"] = 135] = "DC_STR_GROUP_IMAGE_DELETED_BY_OTHER";
  C2[C2["DC_STR_GROUP_IMAGE_DELETED_BY_YOU"] = 134] = "DC_STR_GROUP_IMAGE_DELETED_BY_YOU";
  C2[C2["DC_STR_GROUP_LEFT_BY_OTHER"] = 133] = "DC_STR_GROUP_LEFT_BY_OTHER";
  C2[C2["DC_STR_GROUP_LEFT_BY_YOU"] = 132] = "DC_STR_GROUP_LEFT_BY_YOU";
  C2[C2["DC_STR_GROUP_NAME_CHANGED_BY_OTHER"] = 125] = "DC_STR_GROUP_NAME_CHANGED_BY_OTHER";
  C2[C2["DC_STR_GROUP_NAME_CHANGED_BY_YOU"] = 124] = "DC_STR_GROUP_NAME_CHANGED_BY_YOU";
  C2[C2["DC_STR_IMAGE"] = 9] = "DC_STR_IMAGE";
  C2[C2["DC_STR_INCOMING_MESSAGES"] = 103] = "DC_STR_INCOMING_MESSAGES";
  C2[C2["DC_STR_LAST_MSG_SENT_SUCCESSFULLY"] = 111] = "DC_STR_LAST_MSG_SENT_SUCCESSFULLY";
  C2[C2["DC_STR_LOCATION"] = 66] = "DC_STR_LOCATION";
  C2[C2["DC_STR_LOCATION_ENABLED_BY_OTHER"] = 137] = "DC_STR_LOCATION_ENABLED_BY_OTHER";
  C2[C2["DC_STR_LOCATION_ENABLED_BY_YOU"] = 136] = "DC_STR_LOCATION_ENABLED_BY_YOU";
  C2[C2["DC_STR_MESSAGES"] = 114] = "DC_STR_MESSAGES";
  C2[C2["DC_STR_MSGACTIONBYME"] = 63] = "DC_STR_MSGACTIONBYME";
  C2[C2["DC_STR_MSGACTIONBYUSER"] = 62] = "DC_STR_MSGACTIONBYUSER";
  C2[C2["DC_STR_MSGADDMEMBER"] = 17] = "DC_STR_MSGADDMEMBER";
  C2[C2["DC_STR_MSGDELMEMBER"] = 18] = "DC_STR_MSGDELMEMBER";
  C2[C2["DC_STR_MSGGROUPLEFT"] = 19] = "DC_STR_MSGGROUPLEFT";
  C2[C2["DC_STR_MSGGRPIMGCHANGED"] = 16] = "DC_STR_MSGGRPIMGCHANGED";
  C2[C2["DC_STR_MSGGRPIMGDELETED"] = 33] = "DC_STR_MSGGRPIMGDELETED";
  C2[C2["DC_STR_MSGGRPNAME"] = 15] = "DC_STR_MSGGRPNAME";
  C2[C2["DC_STR_MSGLOCATIONDISABLED"] = 65] = "DC_STR_MSGLOCATIONDISABLED";
  C2[C2["DC_STR_MSGLOCATIONENABLED"] = 64] = "DC_STR_MSGLOCATIONENABLED";
  C2[C2["DC_STR_NEW_GROUP_SEND_FIRST_MESSAGE"] = 172] = "DC_STR_NEW_GROUP_SEND_FIRST_MESSAGE";
  C2[C2["DC_STR_NOMESSAGES"] = 1] = "DC_STR_NOMESSAGES";
  C2[C2["DC_STR_NOT_CONNECTED"] = 121] = "DC_STR_NOT_CONNECTED";
  C2[C2["DC_STR_NOT_SUPPORTED_BY_PROVIDER"] = 113] = "DC_STR_NOT_SUPPORTED_BY_PROVIDER";
  C2[C2["DC_STR_ONE_MOMENT"] = 106] = "DC_STR_ONE_MOMENT";
  C2[C2["DC_STR_OUTGOING_MESSAGES"] = 104] = "DC_STR_OUTGOING_MESSAGES";
  C2[C2["DC_STR_PARTIAL_DOWNLOAD_MSG_BODY"] = 99] = "DC_STR_PARTIAL_DOWNLOAD_MSG_BODY";
  C2[C2["DC_STR_PART_OF_TOTAL_USED"] = 116] = "DC_STR_PART_OF_TOTAL_USED";
  C2[C2["DC_STR_QUOTA_EXCEEDING_MSG_BODY"] = 98] = "DC_STR_QUOTA_EXCEEDING_MSG_BODY";
  C2[C2["DC_STR_READRCPT"] = 31] = "DC_STR_READRCPT";
  C2[C2["DC_STR_READRCPT_MAILBODY"] = 32] = "DC_STR_READRCPT_MAILBODY";
  C2[C2["DC_STR_REMOVE_MEMBER_BY_OTHER"] = 131] = "DC_STR_REMOVE_MEMBER_BY_OTHER";
  C2[C2["DC_STR_REMOVE_MEMBER_BY_YOU"] = 130] = "DC_STR_REMOVE_MEMBER_BY_YOU";
  C2[C2["DC_STR_REPLY_NOUN"] = 90] = "DC_STR_REPLY_NOUN";
  C2[C2["DC_STR_SAVED_MESSAGES"] = 69] = "DC_STR_SAVED_MESSAGES";
  C2[C2["DC_STR_SECURE_JOIN_GROUP_QR_DESC"] = 120] = "DC_STR_SECURE_JOIN_GROUP_QR_DESC";
  C2[C2["DC_STR_SECURE_JOIN_REPLIES"] = 118] = "DC_STR_SECURE_JOIN_REPLIES";
  C2[C2["DC_STR_SECURE_JOIN_STARTED"] = 117] = "DC_STR_SECURE_JOIN_STARTED";
  C2[C2["DC_STR_SELF"] = 2] = "DC_STR_SELF";
  C2[C2["DC_STR_SELF_DELETED_MSG_BODY"] = 91] = "DC_STR_SELF_DELETED_MSG_BODY";
  C2[C2["DC_STR_SENDING"] = 110] = "DC_STR_SENDING";
  C2[C2["DC_STR_SERVER_TURNED_OFF"] = 92] = "DC_STR_SERVER_TURNED_OFF";
  C2[C2["DC_STR_SETUP_CONTACT_QR_DESC"] = 119] = "DC_STR_SETUP_CONTACT_QR_DESC";
  C2[C2["DC_STR_STICKER"] = 67] = "DC_STR_STICKER";
  C2[C2["DC_STR_STORAGE_ON_DOMAIN"] = 105] = "DC_STR_STORAGE_ON_DOMAIN";
  C2[C2["DC_STR_SUBJECT_FOR_NEW_CONTACT"] = 73] = "DC_STR_SUBJECT_FOR_NEW_CONTACT";
  C2[C2["DC_STR_SYNC_MSG_BODY"] = 102] = "DC_STR_SYNC_MSG_BODY";
  C2[C2["DC_STR_SYNC_MSG_SUBJECT"] = 101] = "DC_STR_SYNC_MSG_SUBJECT";
  C2[C2["DC_STR_UNKNOWN_SENDER_FOR_CHAT"] = 72] = "DC_STR_UNKNOWN_SENDER_FOR_CHAT";
  C2[C2["DC_STR_UPDATE_REMINDER_MSG_BODY"] = 86] = "DC_STR_UPDATE_REMINDER_MSG_BODY";
  C2[C2["DC_STR_UPDATING"] = 109] = "DC_STR_UPDATING";
  C2[C2["DC_STR_VIDEO"] = 10] = "DC_STR_VIDEO";
  C2[C2["DC_STR_VIDEOCHAT_INVITATION"] = 82] = "DC_STR_VIDEOCHAT_INVITATION";
  C2[C2["DC_STR_VIDEOCHAT_INVITE_MSG_BODY"] = 83] = "DC_STR_VIDEOCHAT_INVITE_MSG_BODY";
  C2[C2["DC_STR_VOICEMESSAGE"] = 7] = "DC_STR_VOICEMESSAGE";
  C2[C2["DC_STR_WELCOME_MESSAGE"] = 71] = "DC_STR_WELCOME_MESSAGE";
  C2[C2["DC_TEXT1_DRAFT"] = 1] = "DC_TEXT1_DRAFT";
  C2[C2["DC_TEXT1_SELF"] = 3] = "DC_TEXT1_SELF";
  C2[C2["DC_TEXT1_USERNAME"] = 2] = "DC_TEXT1_USERNAME";
  C2[C2["DC_VIDEOCHATTYPE_BASICWEBRTC"] = 1] = "DC_VIDEOCHATTYPE_BASICWEBRTC";
  C2[C2["DC_VIDEOCHATTYPE_JITSI"] = 2] = "DC_VIDEOCHATTYPE_JITSI";
  C2[C2["DC_VIDEOCHATTYPE_UNKNOWN"] = 0] = "DC_VIDEOCHATTYPE_UNKNOWN";
})(C || (C = {}));
